#include <stdlib.h>
#include <stdio.h>


int mat[60][60];   // Ulazna matrica
long sum[60][60];  // Matrica zbira - pomocna
int n;	// Rang matrice
long sm;	// Pamcenje trenutne najbolje sume
int xm1, ym1, xm2, ym2;	// Pamcenje trenutnih najboljih koordinata


// Uchitavanje ulaznih podataka iz datoteke input.txt
// n - rang matrice, elementi matrice

int ReadInp () {

	FILE *fIn;
	int i, j;

	if ((fIn = fopen("input.txt", "rt")) == NULL) return 1;
	if (!fscanf(fIn, "%d", &n)) return 2;
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++)
			if (!fscanf(fIn, "%d", &mat[i][j])) return 2;
	fclose(fIn);

	return 0;
}


// Racunanje pomocne matrice sum - ovo racunanje se moze vrsiti i bez
// pomocne matrice (ako optimizacija zahteva), ali je ovako preglednije

void ComputeSum () {

	int i, j;

	sum[0][0] = mat[0][0];
	for (i = 1; i < n; i++) {
		sum[i][0] = sum[i-1][0] + mat[i][0];
		sum[0][i] = sum[0][i-1] + mat[0][i];
	}

	for (i = 1; i < n; i++)
		for (j = 1; j < n; j++)
			sum[i][j] = sum[i-1][j] + sum[i][j-1] - sum[i-1][j-1] + mat[i][j];
}


// Proveravamo moguce bolje resenje - rasterecenje glavnog programa
void Check (int x1, int y1, int x2, int y2, long s) {

	if (s > sm) {
		sm = s;
		xm1 = x1;
		ym1 = y1;
		xm2 = x2;
		ym2 = y2;
	}
}


// Glavni program

int main (void) {

	int i1, j1, i2, j2, p;	// Brojaci
	long min, minp;	 // Pomocne promenljive

	if (ReadInp ()) {
		fprintf (stderr, "\nLos ulaz !\n");
		return 1;
	}
	ComputeSum ();

	// Inicijalizacija - mora postojati bar jedno polje matrice - prvo :)
	sm = sum[0][0];
	xm1 = 0;
	ym1 = 0;
	xm2 = 0;
	ym2 = 0;

	// Ok, odredjujemo podmatricu....
	for (i1 = 0; i1 < n; i1++)
		for (j1 = 0; j1 < n; j1++) {
			if (i1 > 0)	{	// Mozda mozemo da smanjimo za bolji rezultat
				min = sum[i1-1][j1];
				for (i2 = i1 - 2; i2 >= 0; i2--)
					if (sum[i2][j1] < min) min = sum[i2][j1];
				if (min < 0)	// Mozemo da popravimo sumu
					for (i2 = i1 - 1; i2 >= 0; i2--)
						if (sum[i2][j1] == min) {
							// Inicijalizacija minimuma po koloni
							minp = sum[i1][0] - sum[i2][0];
							p = 0;
							for (j2 = 1; j2 < j1; j2++)
								if (sum[i1][j2] - sum[i2][j2] < minp) {
									p = j2;
									minp = sum[i1][j2] - sum[i2][j2];
								}
							if (j1 == 0) minp = 1;	// Cisto kraci zapis
							if (minp < 0)
								Check (i2 + 1, p + 1, i1, j1, sum[i1][j1] - min - minp);
							else
								Check (i2 + 1, 0, i1, j1, sum[i1][j1] - min);
						}
			}
			if (j1 > 0)	{	// Mozda mozemo da smanjimo za bolji rezultat
				min = sum[i1][j1-1];
				for (j2 = j1 - 2; j2 >= 0; j2--)
					if (sum[i1][j2] < min) min = sum[i1][j2];
				if (min < 0)	// Mozemo da popravimo sumu
					for (j2 = j1 - 1; j2 >= 0; j2--)
						if (sum[i1][j2] == min) {
							// Inicijalizacija minimuma po koloni
							minp = sum[0][j1] - sum[0][j2];
							p = 0;
							for (i2 = 1; i2 < i1; i2++)
								if (sum[i2][j1] - sum[i2][j2] < minp) {
									p = i2;
									minp = sum[i2][j1] - sum[i2][j2];
								}
							if (i1 == 0) minp = 1;	// Cisto kraci zapis
							if (minp < 0)
								Check (p + 1, j2 + 1, i1, j1, sum[i1][j1] - min - minp);
							else
								Check (0, j2 + 1, i1, j1, sum[i1][j1] - min);
						}
			}
		}

	// Prikaz rezultata...
	fprintf (stdout, "\nMaksimalna suma: %d\n", sm);
	fprintf (stdout, "Koordinate (gore levo - dole desno): ");
	fprintf (stdout, "%d %d %d %d\n", xm1 + 1, ym1 + 1, xm2 + 1, ym2 + 1);
	// +1 kod koordinata ubacujemo zbog korekcije - npr. da ne bi bilo 0,3
	// umesto 1,4

	return 0;	// Done !
}